一、通过Code-Server安装
1.1、脚本安装
curl -fsSL https://code-server.dev/install.sh | sh
#!/bin/sh
set -eu# code-server's automatic install script.
# See https://coder.com/docs/code-server/latest/installusage() {arg0="$0"if [ "$0" = sh ]; thenarg0="curl -fsSL https://code-server.dev/install.sh | sh -s --"elsenot_curl_usage="The latest script is available at https://code-server.dev/install.sh
"ficath << EOF
Installs code-server.
It tries to use the system package manager if possible.
After successful installation it explains how to start using code-server.Pass in user@host to install code-server on user@host over ssh.
The remote host must have internet access.
${not_curl_usage-}
Usage:$arg0 [--dry-run] [--version X.X.X] [--edge] [--method detect] \[--prefix ~/.local] [--rsh ssh] [user@host]--dry-runEcho the commands for the install process without running them.--version X.X.XInstall a specific version instead of the latest.--edgeInstall the latest edge version instead of the latest stable version.--method [detect | standalone]Choose the installation method. Defaults to detect.- detect detects the system package manager and tries to use it.Full reference on the process is further below.- standalone installs a standalone release archive into ~/.localAdd ~/.local/bin to your \$PATH to use it.--prefix <dir>Sets the prefix used by standalone release archives. Defaults to ~/.localThe release is unarchived into ~/.local/lib/code-server-X.X.Xand the binary symlinked into ~/.local/bin/code-serverTo install system wide pass ---prefix=/usr/local--rsh <bin>Specifies the remote shell for remote installation. Defaults to ssh.The detection method works as follows:- Debian, Ubuntu, Raspbian: install the deb package from GitHub.- Fedora, CentOS, RHEL, openSUSE: install the rpm package from GitHub.- Arch Linux: install from the AUR (which pulls releases from GitHub).- FreeBSD, Alpine: install from npm.- macOS: install using Homebrew if installed otherwise install from GitHub.- All others: install the release from GitHub.We only build releases on GitHub for amd64 and arm64 on Linux and amd64 for
macOS. When the detection method tries to pull a release from GitHub it will
fall back to installing from npm when there is no matching release for the
system's operating system and architecture.The standalone method will force installion using GitHub releases. It will not
fall back to npm so on architectures without pre-built releases this will error.The installer will cache all downloaded assets into ~/.cache/code-serverMore installation docs are at https://coder.com/docs/code-server/latest/install
EOF
}echo_latest_version() {if [ "${EDGE-}" ]; thenversion="$(curl -fsSL https://api.github.com/repos/coder/code-server/releases | awk 'match($0,/.*"html_url": "(.*\/releases\/tag\/.*)".*/)' | head -n 1 | awk -F '"' '{print $4}')"else# https://gist.github.com/lukechilds/a83e1d7127b78fef38c2914c4ececc3c#gistcomment-2758860version="$(curl -fsSLI -o /dev/null -w "%{url_effective}" https://github.com/coder/code-server/releases/latest)"fiversion="${version#https://github.com/coder/code-server/releases/tag/}"version="${version#v}"echo "$version"
}echo_npm_postinstall() {echohcath << EOF
npm package has been installed.Extend your path to use code-server:PATH="$NPM_BIN_DIR:\$PATH"
Then run with:code-server
EOF
}echo_standalone_postinstall() {echohcath << EOF
Standalone release has been installed into $STANDALONE_INSTALL_PREFIX/lib/code-server-$VERSIONExtend your path to use code-server:PATH="$STANDALONE_INSTALL_PREFIX/bin:\$PATH"
Then run with:code-server
EOF
}echo_brew_postinstall() {echohcath << EOF
Brew release has been installed.Run with:code-server
EOF
}echo_systemd_postinstall() {echohcath << EOF
$1 package has been installed.To have systemd start code-server now and restart on boot:sudo systemctl enable --now code-server@\$USER
Or, if you don't want/need a background service you can run:code-server
EOF
}echo_coder_postinstall() {echohechoh "Deploy code-server for your team with Coder: https://github.com/coder/coder"
}main() {if [ "${TRACE-}" ]; thenset -xfiunset \DRY_RUN \METHOD \OPTIONAL \ALL_FLAGS \RSH_ARGS \EDGE \RSHALL_FLAGS=""while [ "$#" -gt 0 ]; docase "$1" in-*)ALL_FLAGS="${ALL_FLAGS} $1";;esaccase "$1" in--dry-run)DRY_RUN=1;;--method)METHOD="$(parse_arg "$@")"shift;;--method=*)METHOD="$(parse_arg "$@")";;--prefix)STANDALONE_INSTALL_PREFIX="$(parse_arg "$@")"shift;;--prefix=*)STANDALONE_INSTALL_PREFIX="$(parse_arg "$@")";;--version)VERSION="$(parse_arg "$@")"shift;;--version=*)VERSION="$(parse_arg "$@")";;--edge)EDGE=1;;--rsh)RSH="$(parse_arg "$@")"shift;;--rsh=*)RSH="$(parse_arg "$@")";;-h | --h | -help | --help)usageexit 0;;--)shift# We remove the -- added above.ALL_FLAGS="${ALL_FLAGS% --}"RSH_ARGS="$*"break;;-*)echoerr "Unknown flag $1"echoerr "Run with --help to see usage."exit 1;;*)RSH_ARGS="$*"break;;esacshiftdoneif [ "${RSH_ARGS-}" ]; thenRSH="${RSH-ssh}"echoh "Installing remotely with $RSH $RSH_ARGS"curl -fsSL https://code-server.dev/install.sh | prefix "$RSH_ARGS" "$RSH" "$RSH_ARGS" sh -s -- "$ALL_FLAGS"returnfiMETHOD="${METHOD-detect}"if [ "$METHOD" != detect ] && [ "$METHOD" != standalone ]; thenechoerr "Unknown install method \"$METHOD\""echoerr "Run with --help to see usage."exit 1fi# These are used by the various install_* functions that make use of GitHub# releases in order to download and unpack the right release.CACHE_DIR=$(echo_cache_dir)STANDALONE_INSTALL_PREFIX=${STANDALONE_INSTALL_PREFIX:-$HOME/.local}VERSION=${VERSION:-$(echo_latest_version)}# These can be overridden for testing but shouldn't normally be used as it can# result in a broken code-server.OS=${OS:-$(os)}ARCH=${ARCH:-$(arch)}distro_name# Standalone installs by pulling pre-built releases from GitHub.if [ "$METHOD" = standalone ]; thenif has_standalone; theninstall_standaloneecho_coder_postinstallexit 0elseechoerr "There are no standalone releases for $ARCH"echoerr "Please try again without '--method standalone'"exit 1fifi# DISTRO can be overridden for testing but shouldn't normally be used as it# can result in a broken code-server.DISTRO=${DISTRO:-$(distro)}case $DISTRO in# macOS uses brew when available and falls back to standalone. We only have# amd64 for macOS so for anything else use npm.macos)BREW_PATH="${BREW_PATH-brew}"if command_exists "$BREW_PATH"; theninstall_brewelseechoh "Homebrew not installed."echoh "Falling back to standalone installation."npm_fallback install_standalonefi;;# The .deb and .rpm files are pulled from GitHub and we only have amd64 and# arm64 there and need to fall back to npm otherwise.debian) npm_fallback install_deb ;;fedora | opensuse) npm_fallback install_rpm ;;# Arch uses the AUR package which only supports amd64 and arm64 since it# pulls releases from GitHub so we need to fall back to npm.arch) npm_fallback install_aur ;;# We don't have GitHub releases that work on Alpine or FreeBSD so we have no# choice but to use npm here.alpine | freebsd) install_npm ;;# For anything else we'll try to install standalone but fall back to npm if# we don't have releases for the architecture.*)echoh "Unsupported package manager."echoh "Falling back to standalone installation."npm_fallback install_standalone;;esacecho_coder_postinstall
}parse_arg() {case "$1" in*=*)# Remove everything after first equal sign.opt="${1%%=*}"# Remove everything before first equal sign.optarg="${1#*=}"if [ ! "$optarg" ] && [ ! "${OPTIONAL-}" ]; thenechoerr "$opt requires an argument"echoerr "Run with --help to see usage."exit 1fiecho "$optarg"return;;esaccase "${2-}" in"" | -*)if [ ! "${OPTIONAL-}" ]; thenechoerr "$1 requires an argument"echoerr "Run with --help to see usage."exit 1fi;;*)echo "$2"return;;esac
}fetch() {URL="$1"FILE="$2"if [ -e "$FILE" ]; thenechoh "+ Reusing $FILE"returnfish_c mkdir -p "$CACHE_DIR"sh_c curl \-#fL \-o "$FILE.incomplete" \-C - \"$URL"sh_c mv "$FILE.incomplete" "$FILE"
}install_brew() {echoh "Installing latest from Homebrew."echohsh_c "$BREW_PATH" install code-serverecho_brew_postinstall
}install_deb() {echoh "Installing v$VERSION of the $ARCH deb package from GitHub."echohfetch "https://github.com/coder/code-server/releases/download/v$VERSION/code-server_${VERSION}_$ARCH.deb" \"$CACHE_DIR/code-server_${VERSION}_$ARCH.deb"sudo_sh_c dpkg -i "$CACHE_DIR/code-server_${VERSION}_$ARCH.deb"echo_systemd_postinstall deb
}install_rpm() {echoh "Installing v$VERSION of the $ARCH rpm package from GitHub."echohfetch "https://github.com/coder/code-server/releases/download/v$VERSION/code-server-$VERSION-$ARCH.rpm" \"$CACHE_DIR/code-server-$VERSION-$ARCH.rpm"sudo_sh_c rpm -U "$CACHE_DIR/code-server-$VERSION-$ARCH.rpm"echo_systemd_postinstall rpm
}install_aur() {echoh "Installing latest from the AUR."echohsh_c mkdir -p "$CACHE_DIR/code-server-aur"sh_c "curl -#fsSL https://aur.archlinux.org/cgit/aur.git/snapshot/code-server.tar.gz | tar -xzC $CACHE_DIR/code-server-aur --strip-components 1"echo "+ cd $CACHE_DIR/code-server-aur"if [ ! "${DRY_RUN-}" ]; thencd "$CACHE_DIR/code-server-aur"fish_c makepkg -siecho_systemd_postinstall AUR
}install_standalone() {echoh "Installing v$VERSION of the $ARCH release from GitHub."echohfetch "https://github.com/coder/code-server/releases/download/v$VERSION/code-server-$VERSION-$OS-$ARCH.tar.gz" \"$CACHE_DIR/code-server-$VERSION-$OS-$ARCH.tar.gz"# -w only works if the directory exists so try creating it first. If this# fails we can ignore the error as the -w check will then swap us to sudo.sh_c mkdir -p "$STANDALONE_INSTALL_PREFIX" 2> /dev/null || truesh_c="sh_c"if [ ! -w "$STANDALONE_INSTALL_PREFIX" ]; thensh_c="sudo_sh_c"fiif [ -e "$STANDALONE_INSTALL_PREFIX/lib/code-server-$VERSION" ]; thenechohechoh "code-server-$VERSION is already installed at $STANDALONE_INSTALL_PREFIX/lib/code-server-$VERSION"echoh "Remove it to reinstall."exit 0fi"$sh_c" mkdir -p "$STANDALONE_INSTALL_PREFIX/lib" "$STANDALONE_INSTALL_PREFIX/bin""$sh_c" tar -C "$STANDALONE_INSTALL_PREFIX/lib" -xzf "$CACHE_DIR/code-server-$VERSION-$OS-$ARCH.tar.gz""$sh_c" mv -f "$STANDALONE_INSTALL_PREFIX/lib/code-server-$VERSION-$OS-$ARCH" "$STANDALONE_INSTALL_PREFIX/lib/code-server-$VERSION""$sh_c" ln -fs "$STANDALONE_INSTALL_PREFIX/lib/code-server-$VERSION/bin/code-server" "$STANDALONE_INSTALL_PREFIX/bin/code-server"echo_standalone_postinstall
}install_npm() {echoh "Installing latest from npm."echohNPM_PATH="${YARN_PATH-npm}"if command_exists "$NPM_PATH"; thensh_c="sh_c"if [ ! "${DRY_RUN-}" ] && [ ! -w "$(NPM_PATH config get prefix)" ]; thensh_c="sudo_sh_c"fiechoh "Installing with npm."echoh"$sh_c" "$NPM_PATH" install -g code-server --unsafe-permNPM_BIN_DIR="\$($NPM_PATH bin -g)" echo_npm_postinstallreturnfiechoerr "Please install npm to install code-server!"echoerr "You will need at least node v12 and a few C dependencies."echoerr "See the docs https://coder.com/docs/code-server/latest/install#npm"exit 1
}# Run $1 if we have a standalone otherwise run install_npm.
npm_fallback() {if has_standalone; then$1elseechoh "No standalone releases for $ARCH."echoh "Falling back to installation from npm."install_npmfi
}# Determine if we have standalone releases on GitHub for the system's arch.
has_standalone() {case $ARCH inamd64) return 0 ;;# We only have amd64 for macOS.arm64)[ "$(distro)" != macos ]return;;*) return 1 ;;esac
}os() {uname="$(uname)"case $uname inLinux) echo linux ;;Darwin) echo macos ;;FreeBSD) echo freebsd ;;*) echo "$uname" ;;esac
}# Print the detected Linux distro, otherwise print the OS name.
#
# Example outputs:
# - macos -> macos
# - freebsd -> freebsd
# - ubuntu, raspbian, debian ... -> debian
# - amzn, centos, rhel, fedora, ... -> fedora
# - opensuse-{leap,tumbleweed} -> opensuse
# - alpine -> alpine
# - arch, manjaro, endeavouros, ... -> arch
#
# Inspired by https://github.com/docker/docker-install/blob/26ff363bcf3b3f5a00498ac43694bf1c7d9ce16c/install.sh#L111-L120.
distro() {if [ "$OS" = "macos" ] || [ "$OS" = "freebsd" ]; thenecho "$OS"returnfiif [ -f /etc/os-release ]; then(. /etc/os-releaseif [ "${ID_LIKE-}" ]; thenfor id_like in $ID_LIKE; docase "$id_like" in debian | fedora | opensuse | arch)echo "$id_like"return;;esacdonefiecho "$ID")returnfi
}# Print a human-readable name for the OS/distro.
distro_name() {if [ "$(uname)" = "Darwin" ]; thenecho "macOS v$(sw_vers -productVersion)"returnfiif [ -f /etc/os-release ]; then(. /etc/os-releaseecho "$PRETTY_NAME")returnfi# Prints something like: Linux 4.19.0-9-amd64uname -sr
}arch() {uname_m=$(uname -m)case $uname_m inaarch64) echo arm64 ;;x86_64) echo amd64 ;;*) echo "$uname_m" ;;esac
}command_exists() {if [ ! "$1" ]; then return 1; ficommand -v "$@" > /dev/null
}sh_c() {echoh "+ $*"if [ ! "${DRY_RUN-}" ]; thensh -c "$*"fi
}sudo_sh_c() {if [ "$(id -u)" = 0 ]; thensh_c "$@"elif command_exists doas; thensh_c "doas $*"elif command_exists sudo; thensh_c "sudo $*"elif command_exists su; thensh_c "su root -c '$*'"elseechohechoerr "This script needs to run the following command as root."echoerr " $*"echoerr "Please install doas, sudo, or su."exit 1fi
}echo_cache_dir() {if [ "${XDG_CACHE_HOME-}" ]; thenecho "$XDG_CACHE_HOME/code-server"elif [ "${HOME-}" ]; thenecho "$HOME/.cache/code-server"elseecho "/tmp/code-server-cache"fi
}echoh() {echo "$@" | humanpath
}cath() {humanpath
}echoerr() {echoh "$@" >&2
}# humanpath replaces all occurrences of " $HOME" with " ~"
# and all occurrences of '"$HOME' with the literal '"$HOME'.
humanpath() {sed "s# $HOME# ~#g; s#\"$HOME#\"\$HOME#g"
}# We need to make sure we exit with a non zero exit if the command fails.
# /bin/sh does not support -o pipefail unfortunately.
prefix() {PREFIX="$1"shiftfifo="$(mktemp -d)/fifo"mkfifo "$fifo"sed -e "s#^#$PREFIX: #" "$fifo" &"$@" > "$fifo" 2>&1
}main "$@"
1.2、修改配置文件
vim ~/.config/code-server/config.yamlbind-addr: 0.0.0.0:8080
auth: password
password: Lab@123
cert: false#去掉密码验证
bind-addr: 0.0.0.0:8080
auth: none
#password: Lab@123
cert: false
1.3、修改配置文件
/root/.local/share/code-server/User/settings.json
{// 控制头部菜单栏的可见性。“切换”设置表示菜单栏处于隐藏状态,只需按一下 Alt 键即可显示。“精简”设置会将菜单移到边栏中。// - classic: 菜单显示在窗口顶部,并且仅在全屏模式下隐藏。// - visible: 即使在全屏模式下,菜单也始终显示在窗口顶部。// - toggle: 菜单处于隐藏状态,但通过按 Alt 键可在窗口顶部显示。// - hidden: 菜单始终隐藏。// - compact: 菜单在边栏中显示为紧凑按钮。当 `window.titleBarStyle` 为 `native` 时,会忽略此值。"window.menuBarVisibility": "hidden",// 控制是否显示视图头部的操作项。视图头部操作项可以一直,或是仅当聚焦到和悬停在视图上时显示。"workbench.view.alwaysShowHeaderActions": false,// 控制是否可通过 Alt 键快捷键打开主菜单。如果禁用助记符,则可将这些 Alt 键快捷键绑定到编辑器命令。"window.enableMenuBarMnemonics": false,// 控制是否通过按 Alt 键聚焦菜单栏。此设置对使用 Alt 键切换菜单栏没有任何影响。"window.customMenuBarAltFocus": true,// 指定用在工作台中的颜色主题。"workbench.colorTheme": "Default Dark+",// 控制在打开设置时是否同时打开显示所有默认设置的编辑器。"workbench.settings.openDefaultSettings": false,// 控制工作台底部/侧边状态栏的可见性。"workbench.activityBar.visible": false,// 配置字体连字或字体特性。可以是用于启用/禁用连字的布尔值"editor.fontLigatures": false,// 控制打开的编辑器是否显示为预览编辑器。预览编辑器不会保持打开状态,在将其显式设置为保持打开(例如通过双击或编辑)前将会重复使用,其文件名显示样式为斜体。"workbench.editor.enablePreview": false,//启动后界面默认是welcome"workbench.startupEditor": "welcomePage","files.exclude": {// "**/.git": false,// "**/.svn": false,// "**/.hg": false,// "**/CVS": false,// "**/.DS_Store": false,// "**/Thumbs.db": false,// "**/*.crswap": false,"**/*.*": true},"workbench.activityBar.iconClickBehavior": "toggle","workbench.settings.settingsSearchTocBehavior": "hide","workbench.sideBar.location": "hide","window.menuBarVisibility": "hidden",}
1.4、启动访问
systemctl status code-server@$USER
systemctl enable --now code-server@$USER#前台启动调试
code-server
1.5、浏览器访问
http://:8080
1.6、在线安装插件
code-server --install-extension ms-ceintl.vscode-language-pack-zh-hans@1.73.0/root/.local/share/code-server/extensions/ms-ceintl.vscode-language-pack-zh-hans-1.73.0-universal/package.json